commit f918470940d9737396f3a087de4fbb4e70e874a6
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Mon Aug 23 17:16:05 2021

    libstdc++: Add default template argument to basic_istream_view
    
    The standard shows this default template argument in the <ranges>
    synopsis, but it was missing in libstdc++.
    
    libstdc++-v3/ChangeLog:
    
            * include/std/ranges (basic_istream_view): Add default template
            argument.
            * testsuite/std/ranges/istream_view.cc: Check it.
    
    (cherry picked from commit 1a129376bbc26d3c30af3c1ae6036e2e1446db40)

diff --git a/libstdc++-v3/include/std/ranges b/libstdc++-v3/include/std/ranges
index 9d1c4e1356a..3ef352949df 100644
--- a/libstdc++-v3/include/std/ranges
+++ b/libstdc++-v3/include/std/ranges
@@ -632,7 +632,8 @@ namespace views
 	= requires(basic_istream<_CharT, _Traits>& is, _Val& t) { is >> t; };
   } // namespace __detail
 
-  template<movable _Val, typename _CharT, typename _Traits>
+  template<movable _Val, typename _CharT,
+	   typename _Traits = char_traits<_CharT>>
     requires default_initializable<_Val>
       && __detail::__stream_extractable<_Val, _CharT, _Traits>
     class basic_istream_view
diff --git a/libstdc++-v3/testsuite/std/ranges/istream_view.cc b/libstdc++-v3/testsuite/std/ranges/istream_view.cc
index 369790e89e5..af76a1ab39e 100644
--- a/libstdc++-v3/testsuite/std/ranges/istream_view.cc
+++ b/libstdc++-v3/testsuite/std/ranges/istream_view.cc
@@ -83,6 +83,15 @@ test04()
   static_assert(!std::forward_iterator<It>);
 }
 
+void
+test06()
+{
+  // Default template argument
+  using V = std::ranges::basic_istream_view<int, char>;
+  using W = std::ranges::basic_istream_view<int, char, std::char_traits<char>>;
+  static_assert( std::is_same_v<V, W> );
+}
+
 int
 main()
 {
@@ -90,4 +99,5 @@ main()
   test02();
   test03();
   test04();
+  test06();
 }

